#!/usr/bin/perl
#It's already too late to do that check here, but at least try to print a
#warning
if ($> != $<)
{
  print "Must not run with Set-UID bit set\n";
  exit;
}
use English;
use Socket;
use Fcntl qw/O_RDWR O_CREAT O_NOFOLLOW/;
($err_o_nofollow, $MY_O_NOFOLLOW) = Fcntl::constant("O_NOFOLLOW");
if ($err_o_nofollow ne "") { $MY_O_NOFOLLOW = 0; }
use POSIX qw(SEEK_SET SEEK_CUR SEEK_END);
sub bynum {$a <=> $b;}
sub childhnd {
  $childs--;  
  wait();
  return;
}
sub timeout {
  exit(0);
}
sub dprint {
  my($line)=@_;
  unless ($SILENT)
  {
     print "$line";
  }
}
if ($ARGV[0] =~ /^silent$/i) {$SILENT=1;}
$|=1;
#We need to be root at startup so we can bind to the ident port.
if ($< != 0)
{
  print "Need to be root to bind to the ident port\n";
  exit;
}
chdir("/") or die "Can not change working directory";
&dprint("\n***** Random Ident Server 0.9.3b *****\n");
#We first gather our words, this takes some time. If we want to drop privileges
#on restart, we would need to kill the old process before binding to the socket
#and droping privileges. For this reason we gather words before we drop privileges
#as doing so after would leave a large timegap for the service when restarted.
opendir(ISPELL,"/usr/lib/ispell")|| die "No /usr/lib/ispell dir found\n";
@files=readdir(ISPELL);
closedir(ISPELL);
$index=0;
while (($index <= $#files)&&(!$usefile))
{
  $file=$files[$index];
  # Note: As the hash filename is passed to /usr/bin/strings through a shell,
  # we reject any filenames that begin with '-' (interpreted as an option by
  # strings) or that contain a single quote (as we quote the filename in single
  # quotes this would end the quoting).  Aside note: the regexp below does not
  # allow the filename ".hash" either, but we do not care about this.
  if ($file =~ /^[^-'][^']*\.hash$/)
  {
    $usefile=$file;
  }
  $index++;  
}
unless ($usefile) {print "No hash file found in /usr/lib/ispell\n";exit;}
&dprint("* Using file /usr/lib/ispell/'$usefile'\n");
&dprint("* Counting usable words\n");
open(STR1,"/usr/bin/strings /usr/lib/ispell/'$usefile'|")||die "Can't start strings";
while(<STR1>)
{
  chomp();
  chomp();
  $line=lc($_);
  $len=length($line);
  if (($line =~ /^[a-z]+$/)&&($len > 4) && ($len < 13))
  {
    $maxword++;
    if (($maxword % 40) == 0)  { &dprint("\r  working: |  ($maxword)")};
    if (($maxword % 40) == 10) { &dprint("\r  working: /  ($maxword)")};
    if (($maxword % 40) == 20) { &dprint("\r  working: -  ($maxword)")};
    if (($maxword % 40) == 30) { &dprint("\r  working: \\  ($maxword)")};
  }
}
&dprint("\r                                               \r");
close(STR1);
$count=0;
$maxcount=1024+int(rand(2048));
&dprint("* Generating random selection of $maxcount from $maxword\n");
$setsize=$maxword;
@fetched=();
$fnum=0;
while($fnum < $maxcount)
{
  $rnum=int(rand($setsize));
  foreach $old (@fetched)
  {
    if ($old <= $rnum) {$rnum++;}
  }
  $continue=1;
  while($continue)
  {
    $continue=0;
    foreach $old (@fetched) 
    {
       if ($old == $rnum)
       {
         $rnum++;
         $continue=1;
       }
    }
  }
  $fetched[$fnum]=$rnum;
  $fnum++;
  $pnum=int(($fnum*$fnum*1000)/($maxcount*$maxcount))/10;
  if (($fnum %8)==0) {&dprint("\r  working: |  ($pnum \%)");}
  if (($fnum %8)==2) {&dprint("\r  working: /  ($pnum \%)");}
  if (($fnum %8)==4) {&dprint("\r  working: -  ($pnum \%)");}
  if (($fnum %8)==6) {&dprint("\r  working: \\  ($pnum \%)");}
}
&dprint("\r                                \r");
&dprint("* Generating insertion table\n");
foreach $index (0 .. $#fetched)
{
  $inserttable{$fetched[$index]}=$index;
}
open(STR1,"/usr/bin/strings /usr/lib/ispell/'$usefile'|")||die "Can't start strings";
&dprint("* Acquiring names\n");
$count=0;
while(<STR1>)
{
  chomp();
  chomp();
  $line=lc($_);
  $len=length($line);
  if (($line =~ /^[a-z]+$/)&&($len > 4) && ($len < 13))
  {
       if (defined($inserttable{$count}))
       {
         $words[$inserttable{$count}] =$line;
       }
       $count++;
       $countp=int(1000*$count/$maxword)/10;
       if (($count % 40) == 0)  { &dprint("\r  working: |  ($countp \%)")};
       if (($count % 40) == 10) { &dprint("\r  working: /  ($countp \%)")};
       if (($count % 40) == 20) { &dprint("\r  working: -  ($countp \%)")};
       if (($count % 40) == 30) { &dprint("\r  working: \\  ($countp \%)")};
  }
}
&dprint("\r                                 \r");
&dprint("* $maxcount words fetched\n");
&dprint("  (local ports belonging to each unique modulus of $maxcount get\n");
&dprint("   a dictionary word assigned to them)\n");

($pnam,$dummy,$myuid,$mygid)=getpwnam("nobody");
unless (($myuid) && ($mygid))
{
  print "No user nobody defined\n";
  exit;
}
#Just in case  O_NOFOLLOW is not supported we double check.
if (-l "/tmp/rident.pid") {
   print "ERROR: It apears someone has tampered with the pid file /tmp/rident.pid (test1)\n";
   exit;
} elsif (sysopen(PID,"/tmp/rident.pid",O_RDONLY | $MY_O_NOFOLLOW)) {
  $oldpid = 0;
  ($pfuid,$pfgid) = (stat(PID))[4,5] or die "PANIC: Can not stat open pidfile";
  unless ($pfuid == $myuid || $pfgid == $mygid)
  {
    print "ERROR: It apears someone has tampered with the pid file /tmp/rident.pid (test2)\n";
    exit;
  } else {
    #See if the file was already written.
    seek(PID,0,SEEK_END);
    $size=tell(PID);
    seek(PID,0,SEEK_SET);
    #If it was read the old pid.
    if ($size > 0 && $size < 100) {
	  &dprint("* PID file found\n");
	  sysread(PID,$oldpid,$size,0);
	  chomp $oldpid;
	  unless ($oldpid =~ /^\d+$/)
	  {
	    print "ERROR: It apears someone has tampered with the pid file /tmp/rident.pid (test3)\n";
	    exit;
	  }
	  $oldpid +=0;
    } else {
	  &dprint("* PID file is corrupt\n");
	  exit;
    }
  }
  close(PID);
  #Now let's test if the found pid is really our old instance.
  $killit=0;
  if ($oldpid)
  {
    &dprint("* Checking for process with pid $oldpid\n");
    open(PS,"/bin/ps -p '$oldpid'|");
    $killit=0;
    while (<PS>)
    {
       if (/\bridentd\.pl\b/)
       {
	 $killit=$oldpid;
       }
    }
    unless ($killit)
    {
      &dprint("* pid file apears to be old\n");
    } else {
      #We need to kill the old process, but we are root and thus to powerfull.
      $tpid=fork();
      unless (defined($tpid)) {
	print "ERR: Forking error\n";
	exit;
      }
      if ($tpid) {
	#The parent remains root and must wait for the child process.
	&dprint("* Started background process to kill old instance safely\n");
	waitpid($tpid,0);
	&dprint("* Background process finished.\n");
	sleep(1);
      } else {
	unless ($)=$mygid) {print "Cleanup Unable to set group ID to $mygid\n";exit;}
	unless ($>=$myuid) {print "Cleanup Unable to set user ID to $myuid\n";exit;}
	kill(9,$killit);
	exit;
      }
    }
  }
}
&dprint("* Binding to port 113\n");
$port=113;
$proto=getprotobyname('tcp');
socket(Server,PF_INET,SOCK_STREAM,$proto)|| die "socket $!";
setsockopt(Server,SOL_SOCKET,SO_REUSEADDR,pack("l",1))|| die "setsockopt $!";
bind(Server,sockaddr_in($port,INADDR_ANY))|| die "bind: $!";
listen(Server,SOMAXCON)||die "listen: $!";
unlink("/tmp/rident.pid");
&dprint("* Setting uid/gid to nobody $myuid/$mygid\n");
unless ($)=$mygid) { print "Unable to set group ID to $mygid\n"; exit; }
unless ($>=$myuid) { print "Unable to set user ID to $myuid\n"; exit; }
unless (sysopen(PID,"/tmp/rident.pid",O_RDWR | O_CREAT | O_EXCL, 0600)) {
  print "PANIC: Could not create the pid file /tmp/rident.pid $! $?\n";
  exit;
}
&dprint("* Forking to background\n");
$pid=fork();
unless (defined($pid)) {
  print "ERR: Forking error\n";
  close(PID);
  exit;
}
if ($pid)
{
  # parent
  unless (syswrite(PID,"$pid\n",length("$pid\n"))) {
    print "PANIC: Could not write to the pid file /tmp/rident.pid $! $?\n";
    close(PID);
    kill(9,$pid);
  }
  exit;
}
close(PID);
&dprint("* BG Process active\n");
&dprint("* Checking whether we can do socketpair lookups : ");
if (-r "/proc/net/tcp") {
  &dprint("Yep: LINUX\n");
  $LOOKUP="LINUX";
}
else {
  &dprint("NO !!!\n");
  $LOOKUP=0;
}
$childs=0;
$SIG{'CHLD'}='childhnd';
while(1) {
 if ($paddr = accept(Client,Server))
 {
   ($remoteport,$remoteip)=sockaddr_in($paddr);
   $remoteip=unpack("L",$remoteip);
   #Limmited forking and extra sleeping, better for the service than the system to be dossed
   if ($childs < 10)
   {
   $pid=fork();
   unless (defined($pid)) {
     print "ERR: Forking error\n";
     exit;
   }
   if ($pid==0)
   {
     select Client;$|=1;select(STDOUT);
     $SIG{"ALARM"}='timeout';
     alarm(10);
     $firstline=<Client>;
     if ($firstline =~ /(\d+)\s*,\s*(\d*)/)
     {
        $port=$1;
        $port2=$2;
        $found=1;
        #If there is no portablility for the lookup just skip it
        if ($LOOKUP eq "LINUX")
        {
           $found=0;
           $rip=sprintf("%lX",$remoteip);
	   while (length($rip) < 8) {$rip = "0$rip";}
           $rprt=sprintf("%X",$port2);
	   while (length($rprt) < 4) {$rprt = "0$rprt";}
	   $lprt=sprintf("%X",$port);
	   while (length($lprt) < 4) {$lprt = "0$lprt";}
           open(TCPFIL,"/proc/net/tcp");
           while(<TCPFIL>)
           {
             if (/:$lprt\s+${rip}:$rprt\s+/)
             {
               $found=1;
             }
           }
        }
        if ($found)
        {
          $word=$words[$port % $maxcount];
          print Client "${port},${port2}:USERID:OTHER:$word\n";
        }
        else
        {
          print Client "${port},${port2}:ERROR:NO-USER\n";
        }
     }
     close(Client);
     sleep(2);
     exit;
   }
   else
   {
     $childs++;
     close(Client);
   }
   }
   else
   {
     print Client "0,0:ERROR:UNKNOWN-ERROR\n";
     close(Client);
   } 
 }
}

